// hlavickove subory *******************************************************
// systemove funkcie
#include <string.h>
// GL a GLU kniznica
#include <GL/gl.h>
#include <GL/glu.h>
// funkcie SDL kniznice
#include <SDL/SDL.h>

#include "m3Dmath.h"

// .h subor
#include "mObjects.h"

// konstruktor *************************************************************
mObjects::mObjects()
{
 t_a=0.0f; t_b=0.0f;
}

// destruktor **************************************************************
mObjects::~mObjects()
{

}

// definicia objektov - suradnicova sustava ********************************
void mObjects::obj_axis(GLfloat color)
{
 glBegin(GL_LINES);             // ciary
  glColor4f(color,0.0f,0.0f,1.0f);
  for (t_a=0.0f;t_a>-100.0f;t_a-=10.0f) {
   glVertex3f(-50.0f,0.0f,t_a);  // X
   glVertex3f(100.0f,0.0f,t_a);
  }

  glColor4f(0.0f,color,0.0f,1.0f);
  for (t_a=0.0f;t_a>-100.0f;t_a-=10.0f) {
   glVertex3f(0.0f,-50.0f,t_a);  // Y
   glVertex3f(0.0f,100.0f,t_a);
  }

  glColor4f(0.0f,0.0f,color,1.0f);
  for (t_a=0.0f;t_a<100.0f;t_a+=10.0f) {
   glVertex3f(t_a,0.0f,-100.0f); // Z
   glVertex3f(t_a,0.0f,  50.0f);
  }
 glEnd();
}

// definicia objektov - XZ sachovnica **************************************
void mObjects::obj_XZplane(GLfloat color)
{
 glColor4f(color,color,color,1.0f);
 glBegin(GL_LINES);             // ciary
  for (t_a=-50.0f;t_a<=50.0f;t_a+=5.0f) {
   glVertex3f(t_a,0.0f, 50.0f);  // X
   glVertex3f(t_a,0.0f,-50.0f);
  }
  for (t_a=50.0f;t_a>=-50.0f;t_a-=5.0f) {
   glVertex3f(-50.0f,0.0f,t_a); // Z
   glVertex3f( 50.0f,0.0f,t_a);
  }
 glEnd();
}

// definicia objektov - XZ fill sachovnica *********************************
void mObjects::obj_XZplane1(GLfloat color)
{
 glColor4f(color,color,color,1.0f);
 glBegin(GL_QUADS); // plocha
  for (t_b=50.0f;t_b>-50.0f;t_b-=5.0f) {
   for (t_a=-50.0f;t_a<=50.0f;t_a+=5.0f) {
    glNormal3f(0.0f,1.0f,0.0f); glVertex3f(t_a     ,0.0f,t_b);
    glNormal3f(0.0f,1.0f,0.0f); glVertex3f(t_a+5.0f,0.0f,t_b);
    glNormal3f(0.0f,1.0f,0.0f); glVertex3f(t_a+5.0f,0.0f,t_b-5.0f);
    glNormal3f(0.0f,1.0f,0.0f); glVertex3f(t_a     ,0.0f,t_b-5.0f);
   }
  }
 glEnd();
}

// definicia objektov - XZ texturovana plocha ******************************
void mObjects::obj_XZplane2(GLfloat size)
{
 glBegin(GL_QUADS); // plocha
  glNormal3f(0.0f,1.0f,0.0f); glTexCoord2f(     0.0f,0.0f);      glVertex3f(-size,0.0f, size);
  glNormal3f(0.0f,1.0f,0.0f); glTexCoord2f(size/10.0f,0.0f);      glVertex3f( size,0.0f, size);
  glNormal3f(0.0f,1.0f,0.0f); glTexCoord2f(size/10.0f,size/10.0f); glVertex3f( size,0.0f,-size);
  glNormal3f(0.0f,1.0f,0.0f); glTexCoord2f(     0.0f,size/10.0f); glVertex3f(-size,0.0f,-size);
 glEnd();
}

// definicia objektov - kocka biela ****************************************
void mObjects::obj_cube0(GLfloat size)
{
 glColor4f(1.0f,1.0f,1.0f,1.0f); // farba
 glBegin(GL_QUADS);              // kocka
  glNormal3f(0.0f,0.0f,1.0f);
  glVertex3f(-size,-size,size);  // predna stena
  glVertex3f( size,-size,size);
  glVertex3f( size, size,size);
  glVertex3f(-size, size,size);

  glNormal3f(1.0f,0.0f,0.0f);
  glVertex3f(size,-size, size);   // prava stena
  glVertex3f(size,-size,-size);
  glVertex3f(size, size,-size);
  glVertex3f(size, size, size);

  glNormal3f(0.0f,0.0f,-1.0f);
  glVertex3f( size,-size,-size);  // zadna stena
  glVertex3f(-size,-size,-size);
  glVertex3f(-size, size,-size);
  glVertex3f( size, size,-size);

  glNormal3f(-1.0f,0.0f,0.0f);
  glVertex3f(-size,-size,-size); // lava stena
  glVertex3f(-size,-size, size);
  glVertex3f(-size, size, size);
  glVertex3f(-size, size,-size);

  glNormal3f(0.0f,-1.0f,0.0f);
  glVertex3f(-size,-size,-size); // dolna stena
  glVertex3f( size,-size,-size);
  glVertex3f( size,-size, size);
  glVertex3f(-size,-size, size);

  glNormal3f(0.0f,1.0f,0.0f);
  glVertex3f(-size,size, size);   // horna stena
  glVertex3f( size,size, size);
  glVertex3f( size,size,-size);
  glVertex3f(-size,size,-size);
 glEnd();
}

// definicia objektov - kocka farebna **************************************
void mObjects::obj_cube1(GLfloat size)
{
 glBegin(GL_QUADS);               // kocka
  glNormal3f(0.0f,0.0f,1.0f);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(-size,-size,size);   // predna stena
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(size,-size,size);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(size,size,size);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(-size,size,size);

  glNormal3f(1.0f,0.0f,0.0f);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(size,-size,size);    // prava stena
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(size,-size,-size);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(size,size,-size);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(size,size,size);

  glNormal3f(0.0f,0.0f,-1.0f);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(size,-size,-size);   // zadna stena
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(-size,-size,-size);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(-size,size,-size);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(size,size,-size);

  glNormal3f(-1.0f,0.0f,0.0f);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(-size,-size,-size);  // lava stena
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(-size,-size,size);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(-size,size,size);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(-size,size,-size);

  glNormal3f(0.0f,-1.0f,0.0f);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(-size,-size,-size);  // dolna stena
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(size,-size,-size);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(size,-size,size);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(-size,-size,size);

  glNormal3f(0.0f,1.0f,0.0f);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(-size,size,size);    // horna stena
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(size,size,size);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(size,size,-size);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(-size,size,-size);
 glEnd();
}

// definicia objektov - kocka texturovana **********************************
void mObjects::obj_cube2(GLfloat size)
{
 glColor4f(1.0f,1.0f,1.0f,1.0f); // farba
 glBegin(GL_QUADS);              // kocka
  glNormal3f(0.0f,0.0f,1.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-size,-size,size);  // predna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(size,-size,size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(size,size,size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(-size,size,size);

  glNormal3f(1.0f,0.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(size,-size,size);   // prava stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(size,-size,-size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(size,size,-size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(size,size,size);

  glNormal3f(0.0f,0.0f,-1.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(size,-size,-size);  // zadna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(-size,-size,-size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(-size,size,-size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(size,size,-size);

  glNormal3f(-1.0f,0.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-size,-size,-size); // lava stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(-size,-size,size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(-size,size,size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(-size,size,-size);

  glNormal3f(0.0f,-1.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-size,-size,-size); // dolna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(size,-size,-size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(size,-size,size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(-size,-size,size);

  glNormal3f(0.0f,1.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-size,size,size);   // horna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(size,size,size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(size,size,-size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(-size,size,-size);
 glEnd();
}

// definicia objektov - kocka texturovana s normalou v kazdom vrchole ******
void mObjects::obj_cube2N(GLfloat size)
{
 glColor4f(1.0f,1.0f,1.0f,1.0f);  // farba
 glBegin(GL_QUADS);               // kocka
  glNormal3f(-0.577f,-0.577f,0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(-size,-size,size);   // predna stena
  glNormal3f( 0.577f,-0.577f,0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f( size,-size,size);
  glNormal3f( 0.577f, 0.577f,0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f( size, size,size);
  glNormal3f(-0.577f, 0.577f,0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(-size, size,size);

  glNormal3f(0.577f,-0.577f, 0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(size,-size, size);   // prava stena
  glNormal3f(0.577f,-0.577f,-0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f(size,-size,-size);
  glNormal3f(0.577f, 0.577f,-0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f(size, size,-size);
  glNormal3f(0.577f, 0.577f, 0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(size, size, size);

  glNormal3f( 0.577f,-0.577f,-0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f( size,-size,-size); // zadna stena
  glNormal3f(-0.577f,-0.577f,-0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f(-size,-size,-size);
  glNormal3f(-0.577f, 0.577f,-0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f(-size, size,-size);
  glNormal3f( 0.577f, 0.577f,-0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f( size, size,-size);

  glNormal3f(-0.577f,-0.577f,-0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(-size,-size,-size); // lava stena
  glNormal3f(-0.577f,-0.577f, 0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f(-size,-size, size);
  glNormal3f(-0.577f, 0.577f, 0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f(-size, size, size);
  glNormal3f(-0.577f, 0.577f,-0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(-size, size,-size);

  glNormal3f(-0.577f,-0.577f,-0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(-size,-size,-size); // dolna stena
  glNormal3f( 0.577f,-0.577f,-0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f( size,-size,-size);
  glNormal3f( 0.577f,-0.577f, 0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f( size,-size, size);
  glNormal3f(-0.577f,-0.577f, 0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(-size,-size, size);

  glNormal3f(-0.577f,0.577f, 0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(-size,size, size);   // horna stena
  glNormal3f( 0.577f,0.577f, 0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f( size,size, size);
  glNormal3f( 0.577f,0.577f,-0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f( size,size,-size);
  glNormal3f(-0.577f,0.577f,-0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(-size,size,-size);
 glEnd();
}

// inicializacia skyboxu ***************************************************
int mObjects::obj_skybox_init(char *mydir)
{
 char *names[6]={"skyfront","skyback","skybottom","skytop","skyright","skyleft"};
 char filename[128];
 int i;

 // alokovanie miesta pre data textur
 SDL_Surface *TextureImage[6];

 // generovanie jedinecnych identifikatorov 6-tich textur
 glGenTextures(6,skybox_tex_id);

 // vytvorenie textur
 for (i=0;i<6;i++) {
  strcpy(filename,"data/"); strcat(filename,mydir); strcat(filename,"/");
  strcat(filename,names[i]); strcat(filename,".bmp");

  TextureImage[i]=SDL_LoadBMP(filename);

  if (!TextureImage[i]) return(1);

  // vytvorenie textur
  glBindTexture(GL_TEXTURE_2D,skybox_tex_id[i]);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);

  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

  glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[i]->w,TextureImage[i]->h,
               0,GL_BGR,GL_UNSIGNED_BYTE,TextureImage[i]->pixels);
 }

 // uvolnenie pouzitej pamate
 for (i=0;i<6;i++) {
  if (TextureImage[i]) SDL_FreeSurface(TextureImage[i]);
 }

 skybox_DL_id=glGenLists(1);
 glNewList(skybox_DL_id,GL_COMPILE);

 glScalef(3.0f,1.5f,3.0f);

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[0]);
 // predna stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(1,1); glVertex3f(-1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,1); glVertex3f( 1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,0); glVertex3f( 1.0f, 1.0f,-1.0f);
  glTexCoord2f(1,0); glVertex3f(-1.0f, 1.0f,-1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[1]);
 // zadna stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(1,1); glVertex3f( 1.0f,-1.0f,1.0f);
  glTexCoord2f(0,1); glVertex3f(-1.0f,-1.0f,1.0f);
  glTexCoord2f(0,0); glVertex3f(-1.0f, 1.0f,1.0f);
  glTexCoord2f(1,0); glVertex3f( 1.0f, 1.0f,1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[2]);
 // horna stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(0,0); glVertex3f(-1.0f,-1.0f, 1.0f);
  glTexCoord2f(1,0); glVertex3f( 1.0f,-1.0f, 1.0f);
  glTexCoord2f(1,1); glVertex3f( 1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,1); glVertex3f(-1.0f,-1.0f,-1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[3]);
 // spodna stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(0,0); glVertex3f(-1.0f,1.0f,-1.0f);
  glTexCoord2f(1,0); glVertex3f( 1.0f,1.0f,-1.0f);
  glTexCoord2f(1,1); glVertex3f( 1.0f,1.0f, 1.0f);
  glTexCoord2f(0,1); glVertex3f(-1.0f,1.0f, 1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[4]);
 // prava stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(1,1); glVertex3f( -1.0f,-1.0f, 1.0f);
  glTexCoord2f(0,1); glVertex3f( -1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,0); glVertex3f( -1.0f, 1.0f,-1.0f);
  glTexCoord2f(1,0); glVertex3f( -1.0f, 1.0f, 1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[5]);
 // lava stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(1,1); glVertex3f(1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,1); glVertex3f(1.0f,-1.0f, 1.0f);
  glTexCoord2f(0,0); glVertex3f(1.0f, 1.0f, 1.0f);
  glTexCoord2f(1,0); glVertex3f(1.0f, 1.0f,-1.0f);
 glEnd();

 glEndList();

 return(0);
}

// vykreslenie skyboxu *****************************************************
void mObjects::obj_skybox_draw(void)
{
 // ulozenie potrebnych atributov
 glPushAttrib(GL_TEXTURE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT);
 glEnable(GL_TEXTURE_2D);  // zapnutie texturovania
 glDisable(GL_DEPTH_TEST); // vypnutie testu hlbky
 glDisable(GL_LIGHTING);   // vypnutie osvetlenia

 glPushMatrix(); // ulozenie pohladovej matice

 glCallList(skybox_DL_id); // vykonanie prikazov ulozenych v displayliste

 glPopMatrix(); // vyber pohladovej matice

 glPopAttrib(); // obnova ulozenych atributov
}

GLUquadricObj *obj_quad; // kvadratik objekt

// inicializacia kvadratickych objektov ************************************
int mObjects::obj_quadratic_init(void)
{
 obj_quad=gluNewQuadric();               // ukazatel na novy quadratic objekt
 gluQuadricNormals(obj_quad,GLU_SMOOTH); // vyhladene normalove vektory
 gluQuadricTexture(obj_quad,GL_TRUE);    // koordinaty textury

 return(0);
}

// vykreslenie kvadratickeho objektu ***************************************
void mObjects::obj_quadratic(GLuint type,GLfloat param,GLfloat color)
{
 // farba
 glColor4f(color,color,color,1.0f);

 // vyber objektu - gula, valec, ihlan, disk, vysec z disku
 switch (type) {
  case 0: gluSphere(obj_quad,param,32,32); break;
  case 1: gluCylinder(obj_quad,param/4.0f,param/4.0f,param,32,32); break;
  case 2: gluCylinder(obj_quad,param/4.0f,0.0f,param,32,32); break;
  case 3: gluDisk(obj_quad,param/4.0f,param,32,32); break;
  case 4: gluPartialDisk(obj_quad,param/4.0f,param,32,32,0.0f,180.0f); break;
  default: break;
 }
}

// inicializacia sosovkoveho efektu ****************************************
int mObjects::obj_lensflare_init(char *mydir)
{
 char *names[6]={"flare1","flare2","flare3","flare4","flare5","flare6"};
 char filename[128];
 int i;

 // alokovanie miesta pre data textur
 SDL_Surface *TextureImage[6];

 // generovanie jedinecnych identifikatorov 6-tich textur
 glGenTextures(6,lensflare_tex_id);

 // vytvorenie textur
 for (i=0;i<6;i++) {
  strcpy(filename,"data/"); strcat(filename,mydir); strcat(filename,"/");
  strcat(filename,names[i]); strcat(filename,".bmp");

  TextureImage[i]=SDL_LoadBMP(filename);

  if (!TextureImage[i]) return(1);

  // vytvorenie textur
  glBindTexture(GL_TEXTURE_2D,lensflare_tex_id[i]);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);

  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

  glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[i]->w,TextureImage[i]->h,
               0,GL_BGR,GL_UNSIGNED_BYTE,TextureImage[i]->pixels);
 }

 // uvolnenie pouzitej pamate
 for (i=0;i<6;i++) {
  if (TextureImage[i]) SDL_FreeSurface(TextureImage[i]);
 }

 return(0);
}

m3Dvector CameraP,TargetP,UpV,RightV,LightP;
m3Dvector CameraLightVector,LightIntersectVector;
float l;
m3Dvector IntersectP;
m3Dvector middleP,p[4];

GLint VP[4];                        // viewport
GLdouble MVmatrix[16],PRmatrix[16]; // transformacne matice
GLdouble winx,winy,winz;            // vysledne suradnice
GLdouble flareZ; // hlbka svetla
GLfloat bufferZ; // hlbka ulozena v zasobniku hlbky

// test ci sa pred svetlom nachadza iny objekt *****************************
bool isOccluded(m3Dvector point)
{
 glGetIntegerv(GL_VIEWPORT,VP);               // ziskanie viewportu
 glGetDoublev(GL_MODELVIEW_MATRIX,MVmatrix);  // ziskanie modelview matice
 glGetDoublev(GL_PROJECTION_MATRIX,PRmatrix); // ziskanie projekcnej matice
 // prepocet 3D bodu do 2D, vrati poziciu v 2D viewporte
 gluProject(point.x,point.y,point.z,MVmatrix,PRmatrix,VP,&winx,&winy,&winz);
 flareZ=winz;
 // ziskanie hlbky zo zasobnika hlbky
 glReadPixels((GLint) winx,(GLint) winy,1,1,GL_DEPTH_COMPONENT,GL_FLOAT,&bufferZ);

 // ak je "hlbka" svetla viac ako hlbka ulozena v zasobniku hlbky, pred svetlom
 // sa nachadza nejaky iny objekt
 if (bufferZ<flareZ) return true;
 return false;
}

// vykreslenie castice sosovkoveho efektu **********************************
void lflare(GLuint tex_id,
            GLfloat r,GLfloat g,GLfloat b,GLfloat a,
            m3Dvector point,
            GLfloat scale)
{
 // vrchol A
 p[0].x=(point.x+(-RightV.x-UpV.x)*scale);
 p[0].y=(point.y+(-RightV.y-UpV.y)*scale);
 p[0].z=(point.z+(-RightV.z-UpV.z)*scale);
 // vrchol B
 p[1].x=(point.x+(+RightV.x-UpV.x)*scale);
 p[1].y=(point.y+(+RightV.y-UpV.y)*scale);
 p[1].z=(point.z+(+RightV.z-UpV.z)*scale);
 // vrchol C
 p[2].x=(point.x+(+RightV.x+UpV.x)*scale);
 p[2].y=(point.y+(+RightV.y+UpV.y)*scale);
 p[2].z=(point.z+(+RightV.z+UpV.z)*scale);
 // vrchol D
 p[3].x=(point.x+(-RightV.x+UpV.x)*scale);
 p[3].y=(point.y+(-RightV.y+UpV.y)*scale);
 p[3].z=(point.z+(-RightV.z+UpV.z)*scale);

 glPushMatrix();
 glBindTexture(GL_TEXTURE_2D,tex_id); // zvolenie patricnej textury
 glColor4f(r,g,b,a);                  // uprava farby
 glBegin(GL_TRIANGLE_FAN); // vejar trojuholnikov=stvoruholnik
  glTexCoord2f(0.0f,0.0f); glVertex3f(p[0].x,p[0].y,p[0].z);
  glTexCoord2f(1.0f,0.0f); glVertex3f(p[1].x,p[1].y,p[1].z);
  glTexCoord2f(1.0f,1.0f); glVertex3f(p[2].x,p[2].y,p[2].z);
  glTexCoord2f(0.0f,1.0f); glVertex3f(p[3].x,p[3].y,p[3].z);
 glEnd();
 glPopMatrix();
}

// sosovkovy efekt pohladu do svetla (slnka) *******************************
void mObjects::obj_lensflare(GLfloat c1,GLfloat c2,GLfloat c3,
                             GLfloat t1,GLfloat t2,GLfloat t3,
                             GLfloat u1,GLfloat u2,GLfloat u3,
                             GLfloat r1,GLfloat r2,GLfloat r3,
                             GLfloat l1,GLfloat l2,GLfloat l3)
{
 CameraP.x=-c1; CameraP.y=-c2; CameraP.z=-c3; // prevzatie polohy kamery
 TargetP.x=-t1; TargetP.y=-t2; TargetP.z=-t3; // prevzatie smerovaho vektora kamery
 UpV.x=u1; UpV.y=u2; UpV.z=u3;                // prevzatie Up vektora kamery
 RightV.x=r1; RightV.y=r2; RightV.z=r3;       // prevzatie Right vektora kamery
 LightP.x=l1; LightP.y=l2; LightP.z=l3;       // prevzatie polohy svetla

 if (!isOccluded(LightP)) {
  // ak je svetelny zdroj viditelny, dojde k vykresleniu sosovkoveho efektu

  CameraLightVector=LightP-CameraP; // vektor kamera->svetlo
  l=CameraLightVector.Magnitude();  // velkost vektora

  // pozicia priesecnika smeroveho vektora kamery a gulovej plochy
  // s polomerom rovnakym ako vzdialenost kamery od svetla
  IntersectP=CameraP+TargetP*l;
  LightIntersectVector=IntersectP-LightP; // vektor svetlo->priesecnik
  l=LightIntersectVector.Magnitude();     // velkost vektora
  LightIntersectVector.Normalize();       // normalizacia vektora

  // ulozenie potrebnych atributov
  glPushAttrib(GL_TEXTURE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT);
  glEnable(GL_TEXTURE_2D);  // zapnutie texturovania
  glDisable(GL_DEPTH_TEST); // vypnutie testu hlbky
  glDisable(GL_LIGHTING);   // vypnutie osvetlenia

  glEnable(GL_BLEND);               // zapnutie priesvitnosti
  glBlendFunc(GL_SRC_ALPHA,GL_ONE); // kombinacna funkcia pre priesvitnost

  // vykresli sa 1. textura na pozicii svetla
  lflare(lensflare_tex_id[0],0.58f,0.25f,0.23f,0.4f,LightP,600.0f);
  // postupne sa vykreslia textury sosovkoveho efektu v
  // patricnej vzdialenosti od svetelneho zdroja
  middleP=LightP+LightIntersectVector*(l*0.1f);
  lflare(lensflare_tex_id[1],1.0f,1.0f,1.0f,0.1f,middleP,1400.0f);
  middleP=LightP+LightIntersectVector*(l*0.5f);
  lflare(lensflare_tex_id[2],0.10f,0.09f,0.11f,0.4f,middleP,400.0f);
  middleP=LightP+LightIntersectVector*(l*0.6f);
  lflare(lensflare_tex_id[3],0.10f,0.12f,0.16f,0.2f,middleP,200.0f);
  middleP=LightP+LightIntersectVector*(l*0.9f);
  lflare(lensflare_tex_id[3],0.18f,0.09f,0.02f,0.5f,middleP,200.0f);
  middleP=LightP+LightIntersectVector*(l*1.0f);
  lflare(lensflare_tex_id[4],0.30f,0.55f,0.42f,0.2f,middleP,100.0f);
  middleP=LightP+LightIntersectVector*(l*1.3f);
  lflare(lensflare_tex_id[4],0.30f,0.55f,0.42f,0.3f,middleP,200.0f);
  middleP=LightP+LightIntersectVector*(l*1.7f);
  lflare(lensflare_tex_id[2],0.18f,0.09f,0.02f,0.4f,middleP,700.0f);
  middleP=LightP+LightIntersectVector*(l*2.2f);
  lflare(lensflare_tex_id[5],0.04f,0.09f,0.00f,0.5f,middleP,1500.0f);

  glDisable(GL_BLEND); // vyputie priesvitnosti

  glPopAttrib(); // vyber ulozenych atributov
 }
}
