// trieda premennych a funkcii pre pracu s jednoduchymi OpenGL objektmi
class mObjects {
public:
 mObjects();          // konstruktor
 virtual ~mObjects(); // destruktor

 void obj_axis(GLfloat color);     // deklaracia objektov - suradnicova sustava
 void obj_XZplane(GLfloat color);  // deklaracia objektov - XZ sachovnica
 void obj_XZplane1(GLfloat color); // deklaracia objektov - XZ fill sachovnica
 void obj_XZplane2(GLfloat size);  // definicia objektov - XZ texturovana plocha
 void obj_cube0(GLfloat size);     // deklaracia objektov - kocka biela
 void obj_cube1(GLfloat size);     // deklaracia objektov - kocka farebna
 void obj_cube2(GLfloat size);     // deklaracia objektov - kocka ftexturovana
 // deklaracia objektov - kocka texturovana s normalou v kazdom vrchole
 void obj_cube2N(GLfloat size);

 // inicializacia kvadratickych objektov
 int obj_quadratic_init(void);
 // vykreslenie kvadratickeho objektu
 void obj_quadratic(GLuint type,GLfloat param,GLfloat color);

 int obj_skybox_init(char *mydir); // inicializacia skyboxu
 void obj_skybox_draw(void);       // vykreslenie skyboxu

 // inicializacia sosovkoveho efektu
 int obj_lensflare_init(char *mydir);
 // sosovkovy efekt pohladu do svetla (slnka)
 void obj_lensflare(GLfloat c1,GLfloat c2,GLfloat c3,
                    GLfloat t1,GLfloat t2,GLfloat t3,
                    GLfloat u1,GLfloat u2,GLfloat u3,
                    GLfloat r1,GLfloat r2,GLfloat r3,
                    GLfloat l1,GLfloat l2,GLfloat l3);
private:
 GLfloat t_a,t_b; // pomocne premenne

 GLuint skybox_tex_id[6]; // identifikatory textur skybox
 GLuint skybox_DL_id;     // identifikator displaylist skybox

 GLuint lensflare_tex_id[6]; // identifikatory textur lensflare
};
